import { NgModule, CUSTOM_ELEMENTS_SCHEMA  } from '@angular/core';
import { CommonModule } from '@angular/common';
import { WebMapKendoModule } from '@mobilize/winforms-components';
import { WebMapService, WebMapModule } from '@mobilize/angularclient';

import * as SKS from './components/sks';
import * as Definitions from './component_definitions';

@NgModule({
  imports: [
    CommonModule,
    WebMapKendoModule,
    WebMapModule,
  ],
  exports: [
            SKS.FrmSplashComponent,
            SKS.FrmRequestApprovalComponent,
            SKS.FrmActionOrderRequestComponent,
            SKS.FrmActionOrderReceptionComponent,
            SKS.FrmReceptionApprovalComponent,
            SKS.FrmAddProductToComponent,
            SKS.FrmOrderReceptionComponent,
            SKS.FrmAddStockManualComponent,
            SKS.FrmOrderRequestComponent,
            SKS.FrmProvidersComponent,
            SKS.FrmAdjustStockManualComponent,
            SKS.FrmProductsComponent,
            SKS.FrmCustomersComponent,
            SKS.FrmUsersManageComponent,
            SKS.FrmSearchComponent,
            SKS.FrmLoginComponent,
            SKS.FrmAboutComponent,
            SKS.FrmMainComponent,
  ],
  declarations: [
            SKS.FrmSplashComponent,
            SKS.FrmRequestApprovalComponent,
            SKS.FrmActionOrderRequestComponent,
            SKS.FrmActionOrderReceptionComponent,
            SKS.FrmReceptionApprovalComponent,
            SKS.FrmAddProductToComponent,
            SKS.FrmOrderReceptionComponent,
            SKS.FrmAddStockManualComponent,
            SKS.FrmOrderRequestComponent,
            SKS.FrmProvidersComponent,
            SKS.FrmAdjustStockManualComponent,
            SKS.FrmProductsComponent,
            SKS.FrmCustomersComponent,
            SKS.FrmUsersManageComponent,
            SKS.FrmSearchComponent,
            SKS.FrmLoginComponent,
            SKS.FrmAboutComponent,
            SKS.FrmMainComponent,
  ],
  entryComponents: [
            Definitions.SKS_FrmSplashComponent,
            Definitions.SKS_FrmRequestApprovalComponent,
            Definitions.SKS_FrmActionOrderRequestComponent,
            Definitions.SKS_FrmActionOrderReceptionComponent,
            Definitions.SKS_FrmReceptionApprovalComponent,
            Definitions.SKS_FrmAddProductToComponent,
            Definitions.SKS_FrmOrderReceptionComponent,
            Definitions.SKS_FrmAddStockManualComponent,
            Definitions.SKS_FrmOrderRequestComponent,
            Definitions.SKS_FrmProvidersComponent,
            Definitions.SKS_FrmAdjustStockManualComponent,
            Definitions.SKS_FrmProductsComponent,
            Definitions.SKS_FrmCustomersComponent,
            Definitions.SKS_FrmUsersManageComponent,
            Definitions.SKS_FrmSearchComponent,
            Definitions.SKS_FrmLoginComponent,
            Definitions.SKS_FrmAboutComponent,
            Definitions.SKS_FrmMainComponent,
  ],
   providers: [WebMapService],
   schemas: [ CUSTOM_ELEMENTS_SCHEMA ]
})
export class SKSModule { }

