using System;
using System.Windows.Forms;
using UpgradeHelpers.DB.ADO;

namespace SKS
{
	internal partial class frmProviders
		: System.Windows.Forms.Form
	{

		private bool NewMode = false;
		private bool EditMode = false;
		private bool CancellingMode = false;
		public int CurrentProviderID = 0;

		//Private Sub adcProviders_MoveComplete(ByVal adReason As ADODB.EventReasonEnum, ByVal pError As ADODB.Error, adStatus As ADODB.EventStatusEnum, ByVal pRecordset As ADODB.Recordset)
		//NewMode = False
		//EditMode = False
		//CancellingMode = False
		//End Sub

		//Private Sub dcProviders_WillMove(ByVal adReason As ADODB.EventReasonEnum, adStatus As ADODB.EventStatusEnum, ByVal pRecordset As ADODB.Recordset)
		//CancellingMode = True
		//End Sub


		public frmProviders()
			: base()
		{
			if (m_vb6FormDefInstance == null)
			{
				if (m_InitializingDefInstance)
				{
					m_vb6FormDefInstance = this;
				}
				else
				{
					try
					{
						//For the start-up form, the first instance created is the default instance.
						if (System.Reflection.Assembly.GetExecutingAssembly().EntryPoint != null && System.Reflection.Assembly.GetExecutingAssembly().EntryPoint.DeclaringType == this.GetType())
						{
							m_vb6FormDefInstance = this;
						}
					}
					catch
					{
					}
				}
			}
			//This call is required by the Windows Form Designer.
			InitializeComponent();
			ReLoadForm(false);
		}


		//UPGRADE_WARNING: (2080) Form_Load event was upgraded to Form_Load method and has a new behavior. More Information: https://www.mobilize.net/vbtonet/ewis/ewi2080
		private void Form_Load()
		{
			dcProviders.ConnectionString = modMain.ConnectionString;

			NewMode = false;
			EditMode = false;
			CancellingMode = false;
		}

		private void Form_Closed(Object eventSender, EventArgs eventArgs)
		{
			CurrentProviderID = Convert.ToInt32(dcProviders.Recordset["ProviderId"]);
		}

		private void Toolbar1_ButtonClick(Object eventSender, EventArgs eventArgs)
		{
			ToolStripItem Button = (ToolStripItem) eventSender;
			object x = null;
			//SKS Demo TODO: dcProviders.SetFocus()
			switch(Button.Text)
			{
				case "Add" : 
					//Add new record 
					NewMode = true; 
					dcProviders.Recordset.AddNew(); 
					break;
				case "Edit" : 
					//Edit mode 
					EditMode = true; 
					break;
				case "Save" : 
					Save(); 
					break;
				case "Delete" : 
					//Delete record 
					if (MessageBox.Show("Are you sure you want to delete this record?", "Delete record", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == System.Windows.Forms.DialogResult.Yes)
					{
						dcProviders.Recordset.Delete();
						dcProviders.Recordset.Requery();
					} 
					break;
				case "Search" : 
					//Search for records 
					modFunctions.SearchShow("Providers", "ProviderName", "Provider"); 
					break;
				case "Cancel" : 
					CancellingMode = true; 
					//Cancel edited changes 
					EditMode = false; 
					NewMode = false; 
					dcProviders.Recordset.CancelUpdate(); 
					dcProviders.Recordset.Requery(); 
					CancellingMode = false; 
					this.Close(); 
					break;
			}
		}


		private void Save()
		{
			//Save data
			if (modFunctions.TextBoxEmpty(txtField[0]))
			{
				return;
			}
			if (modFunctions.TextBoxEmpty(txtField[1]))
			{
				return;
			}
			if (modFunctions.TextBoxEmpty(txtField[2]))
			{
				return;
			}
			if (modFunctions.TextBoxEmpty(txtField[4]))
			{
				return;
			}
			if (modFunctions.TextBoxEmpty(txtField[5]))
			{
				return;
			}
			if (modFunctions.TextBoxEmpty(txtField[6]))
			{
				return;
			}
			if (modFunctions.TextBoxEmpty(txtField[7]))
			{
				return;
			}
			if (modFunctions.TextBoxEmpty(txtField[7]))
			{
				return;
			}
			if (modFunctions.TextBoxEmpty(txtField[10]))
			{
				return;
			}
			if (modFunctions.TextBoxEmpty(txtField[11]))
			{
				return;
			}
			if (modFunctions.TextBoxEmpty(txtField[12]))
			{
				return;
			}
			if (modFunctions.TextBoxEmpty(txtField[14]))
			{
				return;
			}
			dcProviders.Recordset.Update();
			EditMode = false;
			NewMode = false;
		}

		private void txtField_TextChanged(Object eventSender, EventArgs eventArgs)
		{
			if (!CancellingMode)
			{
				EditMode = true;
			}
		}

		//Used in search form
		//Public Sub SearchCriteria(field As String, value As String)
		//ExecuteSql "Select * from Providers where " & field & " LIKE '" & value & "%'"
		//If rs.RecordCount = 0 Then
		//    MsgBox "There are no records with the selected criteria", vbInformation, "Search"
		//Else
		//    LogStatus "There are " & rs.RecordCount & " that meet with the selected criteria"
		//    Set dcProviders.Recordset = rs
		//End If
		//End Sub
	}
}